% Creates synthetic data 
largeData = false;
if ~largeData
    addpath(genpath('.'))
    datadir = '../experiments/synth/data/';

    n = 700;
    m = 500;
    l = 50;

    K = 3:2:15;
    D = 0.05:0.05:0.3;
    addNoise = 0.05:0.05:0.5;
    desNoise = 0.05:0.05:0.5;

    defK = 7;
    defD = 0.05;
    defAddNoise = 0.1;
    defDesNoise = 0.1;

    iters = 5;
else
    % Creates larger synthetic data 
    addpath(genpath('.'))
    datadir = '../experiments/synth/large_data/';

    n = 1500;
    m = 1200;
    l = 500;

    K = 5:5:50;
    D = 0.05:0.05:0.3;
    addNoise = 0.05:0.05:0.5;
    desNoise = 0.05:0.05:0.5;

    defK = 20;
    defD = 0.05;
    defAddNoise = 0.1;
    defDesNoise = 0.1;

    iters = 5;
end

%% K
d = defD;
dnoise = defDesNoise;
anoise = defAddNoise;

for k=K
    fprintf('k = %i\n', k);
    write_tensors(datadir, 'k', n, m, l, k, d, dnoise, anoise, iters);
end
        
%% D
k = defK;
dnoise = defDesNoise;
anoise = defAddNoise;

for d=D
    fprintf('d = %.2f\n', d);
    write_tensors(datadir, 'd', n, m, l, k, d, dnoise, anoise, iters);
end
    
%% additive Noise
k = defK;
d = defD;
dnoise = defDesNoise;

for anoise=addNoise
    fprintf('anoise = %.2f\n', anoise);
    write_tensors(datadir, 'addNoise', n, m, l, k, d, dnoise, anoise, iters);
end

%% destructive Noise
k = defK;
d = defD;
anoise = defAddNoise;

for dnoise=desNoise
    fprintf('dnoise = %.2f\n', dnoise);
    write_tensors(datadir, 'desNoise', n, m, l, k, d, dnoise, anoise, iters);
end

        
