% Runs synthetic experiments

datadir = '../experiments/synth/data/';
resdir = '../experiments/synth/';
algname = 'bitwise_btc_density5percent';

reps = 1;

N = 200:400:3400;
K = 10:10:80;

l = 500;
numProcs = 1:20;

defN = 800;
defK = 20;
d = 0.05;
noise = 0.1;

iters = 5;

%% cpus
k = defK;
n = defN;

Time = nan(iters, length(numProcs));
j = 0;

for cpus=numProcs
    fprintf(2, 'cpus = %i ', cpus);
    j = j + 1; 
    for i=1:iters
        fprintf(2, '.');
        load(sprintf('%sscale_n%i_m%i_l%i_k%i_d%.2f_desNoise%.2f_addNoise%.2f_iter%i.mat', ...
            datadir, n, n, l, k, d, noise, noise, i));
        T = sptensor(T);
        tic
        [A, B, C, simi]= sparse_bitwise_btc(T.subs, T.size, k, reps, cpus);
        time = toc;
        Time(i, j) = time;
        
        %save(sprintf('%s/%s/scale_n%i_m%i_l%i_k%i_d%.2f_noise%.2f_iter%i.mat', ...
        %    resdir, algname, n, m, l, k, d, noise, i), ...
        %    'mC', 'time', 'sim', 'sim_orig');
    end
    fprintf(2, '\n');
    save(sprintf('%sscale_cpus_%s.mat', resdir, algname), 'Time');
end

%% K
n = defN;

Time = nan(iters, length(K));
j = 0;

for k=K
    fprintf(2, 'k = %i ', k);
    j = j + 1; 
    for i=1:iters
        fprintf(2, '.');
        load(sprintf('%sscale_n%i_m%i_l%i_k%i_d%.2f_desNoise%.2f_addNoise%.2f_iter%i.mat', ...
            datadir, n, n, l, k, d, noise, noise, i));
        T = sptensor(T);
        tic
        [A, B, C, simi] = sparse_bitwise_btc(T.subs, T.size, k, reps, 30);
        time = toc;
        Time(i, j) = time;
        
        %save(sprintf('%s/%s/scale_n%i_m%i_l%i_k%i_d%.2f_noise%.2f_iter%i.mat', ...
        %    resdir, algname, n, m, l, k, d, noise, i), ...
        %    'mC', 'time', 'sim', 'sim_orig');
    end
    fprintf(2, '\n');
    save(sprintf('%sscale_k_%s.mat', resdir, algname), 'Time');
end

%% N
k = defK;

Time = nan(iters, length(N));
j = 0;

for n=N
    fprintf(2, 'n = %i ', n);
    j = j + 1; 
    for i=1:iters
        fprintf(2, '.');
        load(sprintf('%sscale_n%i_m%i_l%i_k%i_d%.2f_desNoise%.2f_addNoise%.2f_iter%i.mat', ...
            datadir, n, n, l, k, d, noise, noise, i));
        T = sptensor(T);
        tic
        [A, B, C, simi]= sparse_bitwise_btc(T.subs, T.size, k, reps, 30);
        time = toc;
        Time(i, j) = time;
        
        %save(sprintf('%s/%s/scale_n%i_m%i_l%i_k%i_d%.2f_noise%.2f_iter%i.mat', ...
        %    resdir, algname, n, m, l, k, d, noise, i), ...
        %    'mC', 'time', 'sim', 'sim_orig');
    end
    fprintf(2, '\n');
    save(sprintf('%sscale_n_%s.mat', resdir, algname), 'Time');
end
        
        
