function Xn = smatricize(X, n)
%SMATRICIZE  Returns the n-mode matricization of sptensor X

N=ndims(X);

if n > N, error(['Cannot do ' int2str(n) '-mode matricization as X has only ' int2str(N) ' modes']); end

Xn = permute(X,[n 1:n-1,n+1:N]);
Xn = spmatrix(reshape(Xn, [size(X,n), prod(size(X))/size(X,n)]));